import { getSdk, } from './graph/generated/operations';
import ErrorStackParser from 'error-stack-parser';
import { GraphQLClient } from 'graphql-request';
var Highlight = /** @class */ (function () {
    function Highlight(options) {
        this._backendUrl = options.backendUrl || 'https://pub.highlight.run';
        // Change to http://localhost:8082/public for development
        var client = new GraphQLClient(this._backendUrl, {
            headers: {},
        });
        this._graphqlSdk = getSdk(client);
    }
    Highlight.prototype.consumeCustomError = function (error, secureSessionId, requestId) {
        var res = [];
        try {
            res = ErrorStackParser.parse(error);
        }
        catch (_a) { }
        var variables = {
            errors: [
                {
                    event: error.message
                        ? "".concat(error.name, ": ").concat(error.message)
                        : "".concat(error.name),
                    request_id: requestId,
                    session_secure_id: secureSessionId,
                    source: '',
                    stackTrace: JSON.stringify(res),
                    timestamp: new Date().toISOString(),
                    type: 'BACKEND',
                    url: '',
                },
            ],
        };
        this._graphqlSdk.PushBackendPayload(variables);
    };
    return Highlight;
}());
export { Highlight };
